/**
 * @author Edouard DUPIN, Kevin BILLONNEAU
 *
 * @copyright 2011, Edouard DUPIN, all right reserved
 *
 * @license APACHE v2.0 (see license file)
 */

package org.gale;

public interface GaleConstants {
	public static final int  GALE_SYSTEM_KEY_VOLUME_UP        = 1;
	public static final int  GALE_SYSTEM_KEY_VOLUME_DOWN      = 2;
	public static final int  GALE_SYSTEM_KEY_MENU             = 3;
	public static final int  GALE_SYSTEM_KEY_CAMERA           = 4;
	public static final int  GALE_SYSTEM_KEY_HOME             = 5;
	public static final int  GALE_SYSTEM_KEY_POWER            = 6;
	// the back key is wrapped in the <esc> key to simplify PC validation ...
	public static final int  GALE_SYSTEM_KEY_BACK             = 0x1B;
	public static final int  GALE_SYSTEM_KEY_DEL              = 0x08;
	
	public static final int  GALE_ORIENTATION_AUTO            = 0;
	public static final int  GALE_ORIENTATION_LANDSCAPE       = 1;
	public static final int  GALE_ORIENTATION_PORTRAIT        = 2;
	
	
	public static final int  GALE_APPL_TYPE_ACTIVITY          = 0;
	public static final int  GALE_APPL_TYPE_WALLPAPER         = 1;
	
	// Key binding of the element gale::key::keyboard :
	public static final int  GALE_MOVE_KEY_LEFT         = 2;
	public static final int  GALE_MOVE_KEY_RIGHT        = 3;
	public static final int  GALE_MOVE_KEY_UP           = 4;
	public static final int  GALE_MOVE_KEY_DOWN         = 5;
	public static final int  GALE_MOVE_KEY_PAGE_UP      = 6;
	public static final int  GALE_MOVE_KEY_PAGE_DOWN    = 7;
	public static final int  GALE_MOVE_KEY_START        = 8;
	public static final int  GALE_MOVE_KEY_END          = 9;
	public static final int  GALE_MOVE_KEY_PRINT        = 10;
	public static final int  GALE_MOVE_KEY_STOP_DEFIL   = 11;
	public static final int  GALE_MOVE_KEY_WAIT         = 12;
	public static final int  GALE_MOVE_KEY_INSERT       = 13;
	public static final int  GALE_MOVE_KEY_F1           = 14;
	public static final int  GALE_MOVE_KEY_F2           = 15;
	public static final int  GALE_MOVE_KEY_F3           = 16;
	public static final int  GALE_MOVE_KEY_F4           = 17;
	public static final int  GALE_MOVE_KEY_F5           = 18;
	public static final int  GALE_MOVE_KEY_F6           = 19;
	public static final int  GALE_MOVE_KEY_F7           = 20;
	public static final int  GALE_MOVE_KEY_F8           = 21;
	public static final int  GALE_MOVE_KEY_F9           = 22;
	public static final int  GALE_MOVE_KEY_F10          = 23;
	public static final int  GALE_MOVE_KEY_F11          = 24;
	public static final int  GALE_MOVE_KEY_F12          = 25;
	public static final int  GALE_MOVE_KEY_CAP_LOCK     = 26;
	public static final int  GALE_MOVE_KEY_SHIFT_LEFT   = 27;
	public static final int  GALE_MOVE_KEY_SHIFT_RIGHT  = 28;
	public static final int  GALE_MOVE_KEY_CTRL_LEFT    = 29;
	public static final int  GALE_MOVE_KEY_CTRL_RIGHT   = 30;
	public static final int  GALE_MOVE_KEY_META_LEFT    = 31;
	public static final int  GALE_MOVE_KEY_META_RIGHT   = 32;
	public static final int  GALE_MOVE_KEY_ALT          = 33;
	public static final int  GALE_MOVE_KEY_ALT_GR       = 34;
	public static final int  GALE_MOVE_KEY_CONTEXT_MENU = 35;
	public static final int  GALE_MOVE_KEY_NUM_LOCK     = 36;
	
}
